require 'sketchup.rb'
Sketchup::require Sketchup.find_support_file("Plugins") + '/Layer Manager/layer_manager'

#-----------------------------------------------------------------------------------------------------
#                                        MENU ITEMS
#-----------------------------------------------------------------------------------------------------

if !file_loaded?("layer_manager_extension_v6.rb")
  
  #Layer tools toolbar
  layertools_tb = UI::Toolbar.new("Layer Tools")
  
  # Set layer(s) of clicked object(s) as current layer
  cmdl0 = UI::Command.new(("Set layer of clicked object current")) { Sketchup.active_model.select_tool(SetClickedObjectLayer.new("current")) } 
  cmdl0.small_icon = "Layer Manager/lm_set_current_16.png"
  cmdl0.large_icon = "Layer Manager/lm_set_current_24.png"
  cmdl0.tooltip = "Set layer of clicked object current"
  layertools_tb.add_item(cmdl0)
  # Set layer(s) of clicked object(s) as current layer and isolated
  cmd1001 = UI::Command.new(("Set layer of clicked object current and isolated")) { Sketchup.active_model.select_tool(SetClickedObjectLayer.new("isolated")) }
  cmd1001.small_icon = "Layer Manager/lm_set_isolate_16.png"
  cmd1001.large_icon = "Layer Manager/lm_set_isolate_24.png"
  cmd1001.tooltip = "Set layer of clicked object current and isolated"
  layertools_tb.add_item(cmd1001)
  # Set layer(s) of clicked object(s) invisible
  cmd0 = UI::Command.new(("Set layer of clicked object invisible")) { Sketchup.active_model.select_tool(SetClickedObjectLayer.new("invisible")) }
  cmd0.small_icon = "Layer Manager/lm_set_invisible_16.png"
  cmd0.large_icon = "Layer Manager/lm_set_invisible_24.png"
  cmd0.tooltip = "Set layer of clicked object invisible"
  layertools_tb.add_item(cmd0)
  #All layers visible
  cmd4 = UI::Command.new(("All layers visible")) { (lm_all_visible) }
  cmd4.small_icon = "Layer Manager/lm_all_visible_16.png"
  cmd4.large_icon = "Layer Manager/lm_all_visible_24.png"
  cmd4.tooltip = "All layers visible"
  layertools_tb.add_item(cmd4)
  #All layers invisible
  cmd6 = UI::Command.new(("All layers invisible")) { (lm_all_invisible) }
  cmd6.small_icon = "Layer Manager/lm_all_invisible_16.png"
  cmd6.large_icon = "Layer Manager/lm_all_invisible_24.png"
  cmd6.tooltip = "All layers invisible (except current)"
  layertools_tb.add_item(cmd6)
  #Invert all layers status
  cmd8 = UI::Command.new(("Toggle visibility of all layers")) { (lm_invert) }
  cmd8.small_icon = "Layer Manager/lm_set_invert_16.png"
  cmd8.large_icon = "Layer Manager/lm_set_invert_24.png"
  cmd8.tooltip = "Toggle visibility of all layers"
  layertools_tb.add_item(cmd8)
  # Select/unselect layer content
  cmd1100 = UI::Command.new(("Select/Deselect layer content")) { Sketchup.active_model.select_tool(SelectClickedObjectLayer.new) }
  cmd1100.small_icon = "Layer Manager/lm_sel_layer_16.png"
  cmd1100.large_icon = "Layer Manager/lm_sel_layer_24.png"
  cmd1100.tooltip = "Select/Deselect layer content"
  layertools_tb.add_item(cmd1100)
  # Move selection to current layer
  cmd00 = UI::Command.new(("Move selection to current layer")) { (lm_selection_to_current) }
  cmd00.small_icon = "Layer Manager/lm_sel_current_16.png"
  cmd00.large_icon = "Layer Manager/lm_sel_current_24.png"
  cmd00.tooltip = "Move selection to current layer"
  layertools_tb.add_item(cmd00)
  #Isolate selection
  cmd5 = UI::Command.new(("Set layers of selection isolated")) { (lm_isolate_selection) }
  cmd5.small_icon = "Layer Manager/lm_sel_isolate_16.png"
  cmd5.large_icon = "Layer Manager/lm_sel_isolate_24.png"
  cmd5.tooltip = "Set layers of selection isolated"
  layertools_tb.add_item(cmd5)
  # Hide layers of selection
  cmd7 = UI::Command.new(("Set layers of selection invisible")) { (lm_hide_selection) }
  cmd7.small_icon = "Layer Manager/lm_sel_hide_16.png"
  cmd7.large_icon = "Layer Manager/lm_sel_hide_24.png"
  cmd7.tooltip = "Set layers of selection invisible"
  layertools_tb.add_item(cmd7)
  #Show (add) using a filter string
  cmd99 = UI::Command.new(("Show layers by filter (add to visible layers)")) { (lm_filter("show")) }
  cmd99.small_icon = "Layer Manager/lm_filter_visible_16.png"
  cmd99.large_icon = "Layer Manager/lm_filter_visible_24.png"
  cmd99.tooltip = "Show layers by filter (add to visible layers)"
  layertools_tb.add_item(cmd99)
  #Isolate using a filter string
  cmd9 = UI::Command.new(("Isolate layers by filter")) { (lm_filter("isolate")) }
  cmd9.small_icon = "Layer Manager/lm_filter_isolate_16.png"
  cmd9.large_icon = "Layer Manager/lm_filter_isolate_24.png"
  cmd9.tooltip = "Isolate layers by filter"
  layertools_tb.add_item(cmd9)  
  #Hide using a filter string
  cmd1000 = UI::Command.new(("Hide layers by filter")) { (lm_filter("hide")) }
  cmd1000.small_icon = "Layer Manager/lm_filter_hide_16.png"
  cmd1000.large_icon = "Layer Manager/lm_filter_hide_24.png"
  cmd1000.tooltip = "Hide layers by filter"
  layertools_tb.add_item(cmd1000)
  #Toggle display layers by color
  cmd901 = UI::Command.new(("Toggle display color by layer")) { lm_toggleDisplayByLayerColor }
  cmd901.small_icon = "Layer Manager/lm_toggle_bycolor_16.png"
  cmd901.large_icon = "Layer Manager/lm_toggle_bycolor_24.png"
  cmd901.tooltip = "Toggle display color by layer"
  layertools_tb.add_item(cmd901)  
  #Match layer
  cmd902 = UI::Command.new(("Match layer property of clicked object")) { Sketchup.active_model.select_tool(MatchClickedObjectLayer.new) }
  cmd902.small_icon = "Layer Manager/lm_set_match_16.png"
  cmd902.large_icon = "Layer Manager/lm_set_match_24.png"
  cmd902.tooltip = "Match layer property of clicked object"
  layertools_tb.add_item(cmd902)
#Create layer with behavior
  cmd1119 = UI::Command.new(("Create layer and control behavior")) { (lm_create_layer_behavior) }
  cmd1119.small_icon = "Layer Manager/lm_create_layer_16.png"
  cmd1119.large_icon = "Layer Manager/lm_create_layer_24.png"
  cmd1119.tooltip = "Create layer and control behavior"
  layertools_tb.add_item(cmd1119)
 #Delete layer
  cmd1129 = UI::Command.new(("Delete layer")) { Sketchup.active_model.select_tool(DeleteClickedObjectLayer.new) }
  cmd1129.small_icon = "Layer Manager/lm_del_lay_16.png"
  cmd1129.large_icon = "Layer Manager/lm_del_lay_24.png"
  cmd1129.tooltip = "Delete layer"
  layertools_tb.add_item(cmd1129)
  #Lock layer
  cmd1229 = UI::Command.new(("Lock layer")) { Sketchup.active_model.select_tool(SetClickedObjectLayer.new("locked")) }
  cmd1229.small_icon = "Layer Manager/lm_set_locked_16.png"
  cmd1229.large_icon = "Layer Manager/lm_set_locked_24.png"
  cmd1229.tooltip = "Lock layer"
  layertools_tb.add_item(cmd1229)
  #Unlock layer
  cmd1329 = UI::Command.new(("Unlock layer")) { Sketchup.active_model.select_tool(SetClickedObjectLayer.new("unlocked")) }
  cmd1329.small_icon = "Layer Manager/lm_set_unlocked_16.png"
  cmd1329.large_icon = "Layer Manager/lm_set_unlocked_24.png"
  cmd1329.tooltip = "Unlock layer"
  layertools_tb.add_item(cmd1329)
  
  #Layer configs toolbar
  layerconfigs_tb = UI::Toolbar.new("Layer Manager")
  
  #Display layer config
  cmd1 = UI::Command.new(("Display layers config")) { (lm_display_config) }
  cmd1.small_icon = "Layer Manager/lm_cfg_display_16.png"
  cmd1.large_icon = "Layer Manager/lm_cfg_display_24.png"
  cmd1.tooltip = "Display layer config"
  layerconfigs_tb.add_item(cmd1)
  #Save layer config in SKP
  cmd3 = UI::Command.new(("Save layers config")) { (lm_save_layers_config_skp) }
  cmd3.small_icon = "Layer Manager/lm_cfg_save_16.png"
  cmd3.large_icon = "Layer Manager/lm_cfg_save_24.png"
  cmd3.tooltip = "Save layers config"
  layerconfigs_tb.add_item(cmd3)
  #Restore layer config from SKP
  cmd2 = UI::Command.new(("Restore layers config")) { (lm_load_layers_config_skp) }
  cmd2.small_icon = "Layer Manager/lm_cfg_restore_16.png"
  cmd2.large_icon = "Layer Manager/lm_cfg_restore_24.png"
  cmd2.tooltip = "Restore layers config"
  layerconfigs_tb.add_item(cmd2)
  #Restore layer config from SKP - Show only
  cmd21 = UI::Command.new(("Restore layers config - Show only")) { (lm_load_layers_config_skp_show_only) }
  cmd21.small_icon = "Layer Manager/lm_cfg_restoreso_16.png"
  cmd21.large_icon = "Layer Manager/lm_cfg_restoreso_24.png"
  cmd21.tooltip = "Restore layers config - Show only"
  layerconfigs_tb.add_item(cmd21)
  #Restore layer config from SKP - Append
  cmd211 = UI::Command.new(("Restore layers config - Append")) { (lm_load_layers_config_skp_append) }
  cmd211.small_icon = "Layer Manager/lm_cfg_restoreap_16.png"
  cmd211.large_icon = "Layer Manager/lm_cfg_restoreap_24.png"
  cmd211.tooltip = "Restore layers config - Append"
  layerconfigs_tb.add_item(cmd211)
  #Update layer configs
  cmd9b = UI::Command.new(("Update layers configs")) { (lm_update_layers_config_skp) }
  cmd9b.small_icon = "Layer Manager/lm_cfg_update_16.png"
  cmd9b.large_icon = "Layer Manager/lm_cfg_update_24.png"
  cmd9b.tooltip = "Update layers config"
  layerconfigs_tb.add_item(cmd9b)
  #Delete layer config
  cmd9 = UI::Command.new(("Delete layers config")) { (lm_delete_layers_config) }
  cmd9.small_icon = "Layer Manager/lm_cfg_delete_16.png"
  cmd9.large_icon = "Layer Manager/lm_cfg_delete_24.png"
  cmd9.tooltip = "Delete layers config"
  layerconfigs_tb.add_item(cmd9)
  #Save layer config to file
  cmd31 = UI::Command.new(("Save layers configs to file")) { (lm_save_layers_config_file) }
  cmd31.small_icon = "Layer Manager/lm_cfg_savef_16.png"
  cmd31.large_icon = "Layer Manager/lm_cfg_savef_24.png"
  cmd31.tooltip = "Save layers configs to file"
  layerconfigs_tb.add_item(cmd31)
  #Restore layer config from file
  cmd2111 = UI::Command.new(("Restore layers configs from file")) { (lm_load_layers_config_file) }
  cmd2111.small_icon = "Layer Manager/lm_cfg_restoref_16.png"
  cmd2111.large_icon = "Layer Manager/lm_cfg_restoref_24.png"
  cmd2111.tooltip = "Restore layers configs from file"
  layerconfigs_tb.add_item(cmd2111)
  
 
#Sketchup.add_observer($lm_AObs=LMAppObserver.new)
#Sketchup.active_model.layers.add_observer($lm_LObs=LMLayersObserver.new)

end
file_loaded("layer_manager_extension_v6.rb")
